import java.awt.*;
import java.awt.event.*;

public class CDProblem extends Frame {

  TextArea taMemo = new TextArea ("", 1, 1,
           TextArea.SCROLLBARS_VERTICAL_ONLY);
  Panel    paUnten = new Panel();
  Button   buBerechnen = new Button();

  int musikstcke[] = 
     {300, 314, 305, 297, 170, 252,
      302, 283, 299, 181, 222,
      273, 290, 355, 170, 242};
  boolean genommen [] = new boolean[16];
  int     gesamtlnge = 0;
  int     hlfte = 0;
  int     optimum;
  
  public CDProblem (String Title) {
    // Frame-Initialisierung
    super(Title);
    addWindowListener(new WindowAdapter() {
      public void windowClosing (WindowEvent evt)
        {System.exit(0);}});
    setSize(300, 300);
    setLayout(new BorderLayout());
    
    // Anfang Komponenten
    taMemo.setText("");
    add("Center", taMemo);
    add("South", paUnten);
    buBerechnen.setLabel("Suchen");
    paUnten.add (buBerechnen);
    buBerechnen.addActionListener (new ActionListener () { 
      public void actionPerformed (ActionEvent evt) { 
        buBerechnenActionPerformed (evt);}});
    // Ende Komponenten
    } // Ende Konstruktor CDProblem
  
  // Anfang Ereignisprozeduren

  public void buBerechnenActionPerformed (ActionEvent evt) {
    gesamtlnge = 0;
    for (int i = 0; i < musikstcke.length; i++)
      gesamtlnge = gesamtlnge + musikstcke[i];
    hlfte = gesamtlnge / 2;
    optimum = gesamtlnge;
    suchbaumAbsuchen(0, 0);
    } // Ende buBerechnenActionPerformed 

  // Ende Ereignisprozeduren
  
  public void zeigeBessereLoesung (int summe) {
    optimum = hlfte - summe;
    taMemo.append("Neue bessere Lsung: " + summe + "|"+ 
                  (gesamtlnge - summe) + "\n");
    for (int i = 0; i < musikstcke.length; i++)
      if (genommen[i])
        taMemo.append(musikstcke[i] + ", ");
    taMemo.append(" | ");
    for (int i = 0; i < musikstcke.length; i++)
      if (!genommen[i])
        taMemo.append(musikstcke[i] + ", ");
    taMemo.append("\n\n");
    } // Ende zeigeBessereLoesung 

  public void suchbaumAbsuchen (int n, int summe) {
    for (int i = n; i < musikstcke.length; i++) {
      // Wir suchen nach der kleineren der beiden CDs
      if (summe + musikstcke[i] <= hlfte) {
        summe = summe + musikstcke[i];
        genommen[i] = true;
        if (hlfte - summe < optimum)
          zeigeBessereLoesung(summe);
        suchbaumAbsuchen(i+1, summe);
        genommen[i] = false;
        summe = summe - musikstcke[i];
        } // Ende if
      } // Ende for
    } // Ende suchbaumAbsuchen

  public static void main (String[] xyz)
    {new CDProblem("CD-Problem").show();}
    
  } // Ende CD-Problem
